diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java
new file mode 100644
index 000000000..f59a43df4
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java
@@ -0,0 +1,69 @@
+package net.minecraft.client.gui.modelviewer.elements;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiSlider;
+import net.minecraft.client.option.FloatOption;
+
+public class GuiListenerSlider extends GuiSlider implements IListenerElement {
+    private IActionListener action;
+    private IKeyListener keyListener;
+    private Runnable onValueChanged;
+    public GuiListenerSlider(int id, int xPosition, int yPosition, FloatOption floatOption) {
+        super(id, xPosition, yPosition, floatOption);
+    }
+
+    public GuiListenerSlider(int id, int xPosition, int yPosition, int width, int height, FloatOption floatOption) {
+        super(id, xPosition, yPosition, width, height, floatOption);
+    }
+
+    public GuiListenerSlider(int id, int xPosition, int yPosition, int width, int height, String text, float defaultValue) {
+        super(id, xPosition, yPosition, width, height, text, defaultValue);
+    }
+    @Override
+    public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY) {
+        float _val = sliderValue;
+        boolean flag = super.mouseClicked(mc, mouseX, mouseY);
+        if (flag && action != null){
+            action.onInteract();
+            if (sliderValue != _val){
+                onValueChanged();
+            }
+        }
+        return flag;
+    }
+    @Override
+    public void mouseDragged(Minecraft mc, int mouseX, int mouseY) {
+        float _val = sliderValue;
+        super.mouseDragged(mc, mouseX, mouseY);
+        if (sliderValue != _val){
+            onValueChanged();
+        }
+    }
+
+    @Override
+    public void setActionListener(IActionListener listener) {
+        action = listener;
+    }
+
+    @Override
+    public void setKeyListener(IKeyListener listener) {
+        keyListener = listener;
+    }
+    @Override
+    public void setOnValueChanged(Runnable runnable){
+        onValueChanged = runnable;
+    }
+    @Override
+    public void onKeyTyped(char c, int key) {
+        if (keyListener != null){
+            keyListener.onKeyPressed(key);
+        }
+    }
+
+    @Override
+    public void onValueChanged() {
+        if (onValueChanged != null){
+            onValueChanged.run();
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java
new file mode 100644
index 000000000..389d185c9
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java
@@ -0,0 +1,187 @@
+package net.minecraft.client.gui.modelviewer.elements;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.text.ITextField;
+import net.minecraft.client.gui.text.TextFieldEditor;
+import net.minecraft.client.render.FontRenderer;
+import org.lwjgl.input.Keyboard;
+
+public class GuiListenerTextField extends GuiListenerButton implements ITextField {
+    private final FontRenderer fontRenderer;
+    private String text = "";
+    private String prefaceText = "";
+    private int maxStringLength;
+    private int cursorCounter;
+    public boolean isFocused;
+    public boolean isEnabled;
+    public boolean removeTextOnClick = false;
+    public GuiScreen parent;
+    private ITextChangeListener textChangeListener;
+    private String placeholder;
+    public boolean drawBackground = true;
+    public final TextFieldEditor editor;
+
+    public GuiListenerTextField(GuiScreen parent, FontRenderer fontrenderer, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
+    {
+        super(-1, xPosition, yPosition, width, height, "");
+        playSound = false;
+        isFocused = false;
+        isEnabled = true;
+        this.parent = parent;
+        fontRenderer = fontrenderer;
+        this.editor = new TextFieldEditor(this);
+        this.placeholder = placeholder;
+        setText(defaultText);
+        editor.setCursor(10000);
+    }
+    public void setPrefaceText(String prefaceText){
+        this.prefaceText = prefaceText;
+    }
+
+    @Override
+    public void setText(String text)
+    {
+        if (text == null) editor.setCursor(0);
+        else if (text.length() < editor.getCursor())
+        {
+            editor.setCursor(text.length());
+        }
+        this.text = text;
+        if(textChangeListener != null) textChangeListener.textChanged(this);
+    }
+
+    @Override
+    public String getText()
+    {
+        return text;
+    }
+
+    public void setPlaceholder(String placeholder) {
+        this.placeholder = placeholder;
+    }
+
+    @Override
+    public void tick()
+    {
+        cursorCounter++;
+    }
+    @Override
+    public void onKeyTyped(char c, int key)
+    {
+        if(!isEnabled || !isFocused) {return;}
+        if(key == Keyboard.KEY_TAB) {
+            if (parent != null) {
+                parent.selectNextField();
+            }
+        }
+        if(editor.handleInput(key, c)) {
+            if(textChangeListener != null) textChangeListener.textChanged(this);
+            if (keyListener != null) keyListener.onKeyPressed(key);
+            onValueChanged();
+        }
+    }
+
+    @Override
+    public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY)
+    {
+        boolean flag = super.mouseClicked(mc, mouseX, mouseY);
+        setFocused(flag);
+        return flag;
+    }
+    protected void onClick(Minecraft mc, int mouseX, int mouseY){
+        if(removeTextOnClick) {
+            setText("");
+        }
+        super.onClick(mc, mouseX, mouseY);
+    }
+
+    public void setFocused(boolean flag)
+    {
+        if(flag && !isFocused)
+        {
+            cursorCounter = 0;
+            editor.setCursor(10000);
+        }
+        isFocused = flag;
+    }
+
+    public void drawButton(Minecraft mc, int mouseX, int mouseY)
+    {
+        if (!visible) return;
+
+        if (drawBackground)
+        {
+            drawRect(xPosition - 1, yPosition - 1, xPosition + width + 1, yPosition + height + 1, 0xffa0a0a0);
+            drawRect(xPosition, yPosition, xPosition + width, yPosition + height, 0xff000000);
+        }
+        if (text.isEmpty() && !isFocused)
+        {
+            drawString(fontRenderer, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
+        }
+
+        if(isEnabled)
+        {
+            boolean drawCursor = isFocused && (cursorCounter / 6) % 2 == 0;
+            int cursor = editor.getCursor();
+            int maxDisplayableChars = this.width / fontRenderer.getCharWidth('_');
+
+            if (!text.isEmpty() || isFocused){
+                if(prefaceText.length() + text.length() <= maxDisplayableChars-1){
+                    drawString(fontRenderer, prefaceText + text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                } else {
+                    //only draw the part of the string that's maxDisplayableChars chars around the cursor
+                    String newString = prefaceText + text;
+                    int begin = Math.max(0,cursor - maxDisplayableChars);
+                    int end = Math.max(maxDisplayableChars,Math.min(newString.length(),cursor));
+                    drawString(fontRenderer, newString.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                }
+            }
+            if (drawCursor)
+            {
+                String currentText = "";
+                if (!text.isEmpty() || isFocused){
+                    currentText = prefaceText + text;
+                }
+                int width = fontRenderer.getStringWidth(currentText);
+                if (cursor < text.length())
+                {
+                    width = fontRenderer.getStringWidth(text.substring(0, cursor)) + fontRenderer.getStringWidth(prefaceText);
+                }
+                if(width >= this.width-4){
+                    // width of the text box - the width of the last character
+                    width = (this.width-4) - fontRenderer.getStringWidth(currentText.substring(currentText.length()-2,currentText.length()-1));
+                }
+                drawString(fontRenderer, "_", xPosition + 4 + width, yPosition + (height - 8) / 2, 0xE0E0E0);
+            }
+        }
+        else
+        {
+            drawString(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
+        }
+    }
+
+    public void setMaxStringLength(int i)
+    {
+        maxStringLength = i;
+    }
+    @Override
+    public int maxLength() {
+        return maxStringLength == 0 ? 1000 : maxStringLength;
+    }
+    @Override
+    public boolean isHovered(int mouseX, int mouseY)
+    {
+        // TODO replace with a better way of allowing keypresses to be recieved while focused
+        return isFocused || super.isHovered(mouseX, mouseY);
+    }
+
+    public void setTextChangeListener(ITextChangeListener textChangeListener) {
+        this.textChangeListener = textChangeListener;
+    }
+
+    public interface ITextChangeListener
+    {
+        void textChanged(GuiListenerTextField textField);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiTextCycle.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiTextCycle.java
new file mode 100644
index 000000000..e1bafcda2
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiTextCycle.java
@@ -0,0 +1,114 @@
+package net.minecraft.client.gui.modelviewer.elements;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.render.FontRenderer;
+
+public abstract class GuiTextCycle<T> extends GuiListenerButton{
+    private T currentElement;
+    private final T defaultElement;
+    public final GuiListenerButton prevButton;
+    public final GuiListenerButton nextButton;
+    public final GuiListenerTextField textField;
+    public GuiTextCycle(GuiScreen parent, FontRenderer fontRenderer, int xPosition, int yPosition, int width, int height, T initialElement) {
+        super(-1, xPosition, yPosition, width, height, "");
+
+        textField = new GuiListenerTextField(parent, fontRenderer, 0, yPosition, width - height * 2 - 2, height, getNameFromElement(initialElement), "");
+        textField.setKeyListener(key -> {
+            String text = textField.getText();
+            setCurrentElement(getElementFromString(text));
+
+            // I have no idea why this is needed but whatever it works
+            textField.setText(text);
+            textField.editor.setCursor(999999);
+            textField.setText(text);
+        });
+
+        prevButton = new GuiListenerButton(-1, xPosition, yPosition, height, height, "<");
+        prevButton.setActionListener(() -> {
+            setCurrentElement(cycleElement(getCurrentElement(), -1));
+        });
+
+        textField.xPosition = prevButton.xPosition + prevButton.width + 1;
+
+        nextButton = new GuiListenerButton(-1, textField.xPosition + textField.width + 1, yPosition, height, height, ">");
+        nextButton.setActionListener(() -> {
+            setCurrentElement(cycleElement(getCurrentElement(), 1));
+        });
+
+        defaultElement = initialElement;
+        currentElement = initialElement;
+    }
+    public void reset(){
+        setCurrentElement(defaultElement);
+    }
+    public void setCurrentElement(T element){
+        boolean flag = currentElement != element;
+        currentElement = element;
+        if (flag) onValueChanged();
+    }
+    public abstract T cycleElement(T current, int offset);
+    public abstract T getElementFromString(String s);
+    public abstract String getNameFromElement(T element);
+    public T getCurrentElement(){
+        return currentElement;
+    }
+    @Override
+    public void onKeyTyped(char c, int key) {
+        textField.onKeyTyped(c, key);
+        super.onKeyTyped(c, key);
+    }
+    @Override
+    public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY) {
+        boolean flag = prevButton.mouseClicked(mc, mouseX, mouseY);
+        flag |= textField.mouseClicked(mc, mouseX, mouseY);
+        flag |= nextButton.mouseClicked(mc, mouseX, mouseY);
+        super.mouseClicked(mc, mouseX, mouseY);
+        return flag;
+
+    }
+    @Override
+    public void tick()
+    {
+        prevButton.tick();
+        nextButton.tick();
+        textField.tick();
+    }
+    @Override
+    public void drawButton(Minecraft mc, int mouseX, int mouseY)
+    {
+        if (!visible) return;
+        prevButton.enabled = enabled;
+        prevButton.drawButton(mc, mouseX, mouseY);
+        nextButton.enabled = enabled;
+        nextButton.drawButton(mc, mouseX, mouseY);
+        textField.enabled = enabled;
+        textField.drawButton(mc, mouseX, mouseY);
+    }
+    @Override
+    public void onValueChanged(){
+        super.onValueChanged();
+        textField.setText(getNameFromElement(getCurrentElement()));
+    }
+    @Override
+    public void setX(int x) {
+        this.xPosition = x;
+        prevButton.setX(x);
+        nextButton.setX(x + getWidth() - nextButton.getWidth());
+        textField.setX(x + nextButton.width + 1);
+    }
+
+    @Override
+    public void setY(int y) {
+        this.yPosition = y;
+        prevButton.setY(y);
+        nextButton.setY(y);
+        textField.setY(y);
+    }
+    @Override
+    public boolean isHovered(int mouseX, int mouseY)
+    {
+        // TODO replace with a better way of allowing keypresses to be recieved while focused
+        return textField.isFocused || super.isHovered(mouseX, mouseY);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/IActionListener.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/IActionListener.java
new file mode 100644
index 000000000..2864f3488
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/IActionListener.java
@@ -0,0 +1,6 @@
+package net.minecraft.client.gui.modelviewer.elements;
+
+@FunctionalInterface
+public interface IActionListener {
+    void onInteract();
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/IKeyListener.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/IKeyListener.java
new file mode 100644
index 000000000..69dfafbc9
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/IKeyListener.java
@@ -0,0 +1,5 @@
+package net.minecraft.client.gui.modelviewer.elements;
+@FunctionalInterface
+public interface IKeyListener {
+    void onKeyPressed(int key);
+}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/IListenerElement.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/IListenerElement.java
new file mode 100644
index 000000000..98a74d34d
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/IListenerElement.java
@@ -0,0 +1,9 @@
+package net.minecraft.client.gui.modelviewer.elements;
+
+public interface IListenerElement {
+    void setActionListener(IActionListener listener);
+    void setKeyListener(IKeyListener listener);
+    void setOnValueChanged(Runnable action);
+    void onKeyTyped(char c, int key);
+    void onValueChanged();
+}
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 1b75daccd..8bf33c70c 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -1,13 +1,19 @@
 package net.minecraft.client.gui.options.data;
 
+import net.betterthanadventure.utils.BiomeFinder;
+import net.betterthanadventure.utils.DataDumper;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiControllerSetup;
 import net.minecraft.client.gui.GuiHudDesigner;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.gui.options.components.*;
+import net.minecraft.client.player.controller.PlayerControllerSP;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Utils;
+import net.minecraft.core.world.World;
 
 import java.io.File;
 
@@ -85,6 +91,7 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.heatHaze))
         )
         .withComponent(new OptionsCategory("gui.options.page.video.category.visuals")
+            .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.lightmapStyle))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.fog))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.biomeWater))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.treeShadows))
@@ -206,6 +213,22 @@ public abstract class OptionsPages
     public static final OptionsPage SEARCH = register(new OptionsPage("gui.options.page.search.title", new ItemStack(Block.glass))
         .withComponent(new SearchFieldComponent())
     );
+    public static final OptionsPage DEBUG = new OptionsPage("gui.options.page.debug.title", Block.bedrock.getDefaultStack())
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
+                mc.playerController = new PlayerControllerSP(mc);
+                mc.changeWorld(new World(), "Loading Model Viewer");
+                mc.displayGuiScreen(new GuiModelViewer());})
+            )
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.biome_finder", () -> {
+                BiomeFinder.main(new String[0]);
+                Global.accessor = mc;
+            }))
+            .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () ->{
+                DataDumper.main(new String[0]);
+                Utils.openDirectory(new File(mc.getMinecraftDir(), "infodump"));
+                Global.accessor = mc;
+            }))
+            ;
 
     public static OptionsPage register(OptionsPage page)
     {
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index dbce20936..e88aace56 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -8,6 +8,7 @@ import java.io.FileReader;
 import java.io.FileWriter;
 import java.io.PrintWriter;
 
+import net.minecraft.client.option.enums.*;
 import net.minecraft.client.render.tessalator.TessellatorStandard;
 import org.lwjgl.opengl.Display;
 
@@ -16,13 +17,7 @@ import com.b100.utils.ReflectUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.gui.hud.HudComponents;
-import net.minecraft.client.option.enums.Colorblindness;
-import net.minecraft.client.option.enums.Difficulty;
-import net.minecraft.client.option.enums.MipmapType;
 import net.minecraft.core.enums.PlacementMode;
-import net.minecraft.client.option.enums.RenderDistance;
-import net.minecraft.client.option.enums.RenderScale;
-import net.minecraft.client.option.enums.TooltipStyle;
 import net.minecraft.client.render.window.GameWindowLWJGL2;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -155,7 +150,7 @@ public class GameSettings {
 	public BooleanOption borderlessFullscreen = new BooleanOption(this, "borderlessFullscreen", true);
 	public BooleanOption startInFullscreen = new BooleanOption(this, "startInFullscreen", true);
 	public EnumOption<TooltipStyle> tooltipStyle = new EnumOption<>(this, "tooltipStyle", TooltipStyle.class);
-	
+	public EnumOption<LightmapStyle> lightmapStyle = new EnumOption<>(this, "lightmapStyle", LightmapStyle.class, LightmapStyle.DEFAULT);
 	public BooleanOption fog = new BooleanOption(this, "fog", true);
 	public BooleanOption hideUndiscoveredItems = new BooleanOption(this, "hideUndiscoveredItems", true);
 	public BooleanOption muteOnLostFocus = new BooleanOption(this, "muteOnLostFocus", false);
@@ -320,6 +315,9 @@ public class GameSettings {
 				return trans.translateKey("options.graphics.fast");
 			}
 		}
+		if (option == lightmapStyle) {
+			return trans.translateKey(lightmapStyle.value.getTranslationKey());
+		}
 		if(option == bloom) {
 			if(bloom.value == 0) {
 				return trans.translateKey("options.off");
@@ -405,6 +403,11 @@ public class GameSettings {
 				mc.renderGlobal.loadRenderers();
 			}
 		}
+		if(option == lightmapStyle) {
+			if (mc.renderGlobal != null) {
+				mc.renderGlobal.loadRenderers();
+			}
+		}
 	}
 
 	public void loadOptions() {
diff --git a/src/main/java/net/minecraft/client/option/enums/LightmapStyle.java b/src/main/java/net/minecraft/client/option/enums/LightmapStyle.java
new file mode 100644
index 000000000..36450e11c
--- /dev/null
+++ b/src/main/java/net/minecraft/client/option/enums/LightmapStyle.java
@@ -0,0 +1,17 @@
+package net.minecraft.client.option.enums;
+
+public enum LightmapStyle {
+    DEFAULT("options.lightmapStyle.default"),
+    COSY("options.lightmapStyle.cosy"),
+    DISABLED("options.lightmapStyle.disabled");
+
+    private final String translationKey;
+
+    LightmapStyle(String translationKey) {
+        this.translationKey = translationKey;
+    }
+
+    public String getTranslationKey() {
+        return this.translationKey;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/ChunkRenderer.java b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
index e2e0a9e87..a75ad9c5b 100644
--- a/src/main/java/net/minecraft/client/render/ChunkRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
@@ -131,6 +131,11 @@ public class ChunkRenderer
                             GL11.glTranslatef((float)sizeDepth / 2.0F, (float)sizeHeight / 2.0F, (float)sizeDepth / 2.0F);
                             tessellator.startDrawingQuads();
                             tessellator.setTranslation(-posX, -posY, -posZ);
+                            
+                            if(LightmapHelper.isLightmapEnabled()) {
+                            	// Make sure it's active
+                            	tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+                            }
                         }
                         if(renderPass == 0 && Block.isEntityTile[blockId])
                         {
@@ -148,6 +153,11 @@ public class ChunkRenderer
                         }
                         else
                         {
+                        	if(LightmapHelper.isLightmapEnabled()) {
+                        		// Can probably be removed once all block models support the lightmap
+                        		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));	
+                        	}
+                            
                             BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
                             hasRenderedBlock |= model.render(tessellator, x, y, z);
                             if (model.hasOverbright())
diff --git a/src/main/java/net/minecraft/client/render/FogManager.java b/src/main/java/net/minecraft/client/render/FogManager.java
index 1a6ad6266..d262f9357 100644
--- a/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/src/main/java/net/minecraft/client/render/FogManager.java
@@ -9,10 +9,12 @@ import org.lwjgl.opengl.NVFogDistance;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.option.enums.RenderDistance;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.colorizer.ColorizerWater;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.Dimension;
@@ -168,6 +170,12 @@ public class FogManager {
         fogRed *= brightness;
         fogGreen *= brightness;
         fogBlue *= brightness;
+        if (mc.currentScreen instanceof GuiModelViewer) {
+            float[] color = ((GuiModelViewer) mc.currentScreen).getBackgroundFogColor();
+            fogRed = color[0];
+            fogGreen = color[1];
+            fogBlue = color[2];
+        }
         glClearColor(fogRed, fogGreen, fogBlue, 0.0F);
     }
 
